//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "decode.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)

int decode_buffer( BYTE *inp_buf, BYTE *out_buf, int cnt)
{
  BYTE byte;
  BYTE overflow_byte;
  int rem;
  int i;
  int j;
  int m;
  int n;

  int Result = 0;
  m = ( ( cnt - 1 ) / 7 ) + 1;
  for (j=0; j<m; j=j+1) {
    if ( j == ( m - 1 ) )
	{
        rem = cnt % 7;
    	n = rem ? rem : 7;
	}
    else
            n = 7;
    overflow_byte = *( inp_buf + n );
    for ( i = 0; i < n; i = i + 1 )
            {
            byte = *inp_buf++ | ( ( overflow_byte << ( 7 - i ) ) & 0x80 );
            *out_buf++ = byte;
            Result++;
            }
    inp_buf++;  // skip overflow byte
  }
  return Result;
}


void encode_buffer( Byte *inp_buf, Byte *out_buf, int cnt )
{
	Byte byte;
	Byte overflow_byte;
	int rem;
	int i;
	int j;
	int m;
	int n;

	m = ( ( cnt - 1 ) / 7 ) + 1;
	for ( j = 0; j < m; j = j + 1 )
		{
		if ( j == ( m - 1 ) )	//	last group of bytes:
		{
			rem = cnt % 7;
			n = rem ? rem : 7;
		}
		else
			n = 7;

		overflow_byte = 0x00;
		for ( i = 0; i < n; i = i + 1 )
			{
			byte = *inp_buf++;
			overflow_byte = overflow_byte | ( ( byte & 0x80 ) >> ( 7 - i ) );
			*out_buf++ = byte & 0x7F;
			}
		*out_buf++ = overflow_byte;  // store overflow byte
		}
}

int build_serial_data_out_buffer(Byte *data_output_buf, int type, short int num)
{
	int byte_count;
	switch ( type )
		{
		case 0 :
		case 128 :
			data_output_buf[ 0 ] = 0;  // status = normal
			data_output_buf[ 1 ] = Byte(num >> 8);/* pd MSB */
			data_output_buf[ 2 ] = Byte (num);/* pd LSB */
			data_output_buf[ 3 ] = 0;
			data_output_buf[ 4 ] = 2;   /* horiz eye coord MSB */
			data_output_buf[ 5 ] = 3;   /* horiz eye coord LSB */
			data_output_buf[ 6 ] = 4;   /* vert eye coord MSB */
			data_output_buf[ 7 ] = 5;  /* vert eye coord LSB */
			byte_count = 8;
			break;

		case 2:
        case 130:
			data_output_buf[ 0 ] = 1;  // status = target point.
			data_output_buf[ 1 ] = Byte(num>>8);
			data_output_buf[ 2 ] = Byte(num);
			data_output_buf[ 3 ] = 1;
			data_output_buf[ 4 ] = 1;
			data_output_buf[ 5 ] = 2;
			data_output_buf[ 6 ] = 2;
			data_output_buf[ 7 ] = 0;	//	unused
			byte_count = 7;
			break;
		//	append uncalibrated data:
		case 3 :
		case 131 :
			data_output_buf[ 0 ] = 2;  // status = uncalibrated data and xdat are added.
			data_output_buf[ 1 ] = Byte(num>>8);
			data_output_buf[ 2 ] = Byte(num);
			data_output_buf[ 3 ] = 0;
			data_output_buf[ 4 ] = 0;
			data_output_buf[ 5 ] = 1;
			data_output_buf[ 6 ] = 0;
			data_output_buf[ 7 ] = 2;
            // uncalibrated data:
			// 		pupil
			//	TOTAL BYTE COUNT:
    		byte_count = 18;
			data_output_buf[ 8 ] = 0;
			data_output_buf[ 9 ] = 3;
			data_output_buf[ 10 ] = 0;
			data_output_buf[ 11 ] = 4;
			//		cr:
			data_output_buf[ 12 ] = 0;
 			data_output_buf[ 13 ] = 5;
			data_output_buf[ 14 ] = 0;
			data_output_buf[ 15 ] = 6;
			//		xdat:
			data_output_buf[ 16 ] = 0;
         data_output_buf[ 17 ] = 7;
			break;
		default :
			byte_count = 0;
			break;
		}
	return( byte_count );
}   

