#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <stream.h>
#include <iostream.h>

#define FIRST_FRAME 10
#define FRAME_RATE 30      //Player gives so many frames per second

#define FRAMES     10000
#define W 708
#define H 480
#define X_SHIFT    1
#define Y_SHIFT    1


#define IN_DATA_EYE_FILE "eye.in"     //The file with eye gazes from eye tracker
//#define IN_DATA_EYE_FILE "toy_car_eye.out"     //The file with eye gazes from eye tracker
#define ANG_VEL_FILE "ang_vel_eye.out"               // Max linear eye velocity for 1 sec (in degrees)
#define PIX_VEL_FILE "pix_vel_eye.out"               // Max linear eye velocity for 1 sec (in pixels)

//Here program writes neccesary additions to the file name
#define ACUITY_FILE            "acuity"
#define FILTERED_EYE_FILE      "filtered_eye_data"      //File for transcoder - with filtered eye gazes
#define MEASURED_SPEED_FILE    "predict_vel_eye"        //Angular speed with wich algorithm provides us
#define AREA_COVERED_FILE      "area_cover_win"         //Window frame coverage


#define WP 13.25            //Physical image width (inches)
#define HP 9                //Physical image height (inches)
#define L  32               //Distance between subject and screen (inches)

#define X_TRESHHOLD 50
#define Y_TRESHHOLD 50

FILE *infile;
FILE *outfile;
FILE *in_data_file;
FILE *ang_vel_file;
FILE *pix_vel_file;
FILE *area_cov_file;
FILE *par_file;

 char X[10],Y[10];
 int current_frame=0;
 int frame_count=0;
 double V_x=0,V_y=0;                 //End velosity values - measured in percents
 double Va_x=0,Va_y=0;               //Average velosity values - measured in pixels
 int Vtt_x=0,Vtt_y=0,Vt_x=0,Vt_y=0;  //Temprorary velocity values - measured in percents
 int velocity_count=0;               //Number of samples
 int Fmax=0;                         //Maximum number of frames
 int i,j;
 double time_ratio=0;                //Ratio between delay and number of frames
 int x_mov=0;                        //Movement for x coord of eye
 int y_mov=0;                        //Movement for y coord of eye
 int Xp=0, Yp=0;                     //Coordinated of the eye gaze - measured in percents
 int in_count=0;
 int out_count=0;
 int x_max_vel=0;                    //Maximum x eye movement for 1 sec
 int y_max_vel=0;                    //Maximum y eye movement for 1 sec
 int GOP_count=0;
 int vel_ar_x[W/X_SHIFT];           //Values for storing percentage of velosity - count
 int vel_ar_y[H/Y_SHIFT];           //Values for storing percentage of velosity - count
 int gen_frame_count=0;
 int gaze_point_count=0;
 int x_gaze=0;			   //Number of X gazes to keep in window
 int y_gaze=0;                     //Number of Y gazes to keep in window
 int gaze_coeff=0;                 //Proportion between acuty and number of gazes
 int static_a=0;		   //Value for measuring
 int static_b=0;
 int dynamic_a=0;
 int dynamic_b=0;
 int count=0;
 double tempf=0;
 int sec_in_count=0;
 int sec_out_count=0;
 int sec_frame_count=0;
 int x=0,y=0;
 double total_gaze_count=0;
 double x_filter_count=0;
 double y_filter_count=0;
 int Wx_t=0, Hy_t=0;           //Velovity values - measured in pixels
 double x_mov_tmp=0, y_mov_tmp=0;



class Frame
{
  public:
  int x[10];
  int y[10];
  int gaze_point;  //Maximum number of gazes in the frame
  int i;

  void Add_Point(int Xc,int Yc)
  {
    x[gaze_point]=Xc;
    y[gaze_point]=Yc;
    gaze_point++;
  }

  void Print_Data()
  {
    for(i=0;i<gaze_point;i++)
    {
      printf("%d %d\n",x[i],y[i]);
    }
  }

  void Print_File()
  {
    for(i=0;i<gaze_point;i++)
    {
      fprintf(outfile,"%d %d\n",x[i],y[i]);
    }
  }

  int Ret_X()
  {
    return x[gaze_point-1];
  }

  int Ret_Y()
  {
    return y[gaze_point-1];
  }

  int Ret_Xi(int i)
  {
    return x[i];
  }

  int Ret_Yi(int i)
  {
    return y[i];
  }
};


Frame frame[FRAMES];

bool In_Window(int Xc, int Yc, int Xp, int Yp, int a, int b)
{
  if(((0.1*(Xc-Xp)*(Xc-Xp)/(0.1*a*a))+(0.1*(Yc-Yp)*(Yc-Yp)/(0.1*b*b)))<=1.0)
  {
    return 1;
  }
  else
  {
    return 0;
  }
}


void Dynamic_Window(int delay, int koeff, int acuity)
{
 //delay - Delay in number of frames
 //koeff - Koefficient  to provide target accuracy
 //Setting count variables to 0
 FILE *acuity_file;
 FILE *filtered_eye_data_file;
 FILE *predicted_eye_vel_file;
 double x1=0, y1=0, a=0, b=0;
 int mb_width=0, mb_height2=0;
 char file_name[256];
 double av_area_coverage=0;
 int mb_in_window=0, mb_out_window=0;
 int j, i;
 int k=0, n=0;
 int mb_frame_count=0;
 mb_width=W/16;
 mb_height2=H/16;
 frame_count=0;
 Vt_x=0;
 Vt_y=0;
 Vtt_x=0;
 Vtt_y=0;
 Va_x=0;
 Va_y=0;
 x_max_vel=0;
 y_max_vel=0;
 GOP_count=0;
 in_count=0;
 out_count=0;
 count=0;
 sec_in_count=0;
 sec_out_count=0;
 sec_frame_count=0;
 x_mov=0;
 y_mov=0;
 dynamic_a=0;
 dynamic_b=0;

 printf("%d %d\n",mb_width, mb_height2);

 for(i=0;i<W/X_SHIFT;i++)
   vel_ar_x[i]=0;
 for(i=0;i<H/Y_SHIFT;i++)
   vel_ar_y[i]=0;
 //Set beginning values for Vtt_x and Vtt_y


 memset(file_name,'\0',256);
 sprintf(file_name,"%s_d%d.out",ACUITY_FILE,delay);
 if((acuity_file=fopen(file_name,"w"))==NULL)
  printf("File %s could not be opened\n",file_name);

 memset(file_name,'\0',256);
 sprintf(file_name,"%s_d%d_ta%d_k%d.out",FILTERED_EYE_FILE,delay,acuity,koeff);
 if((filtered_eye_data_file=fopen(file_name,"w"))==NULL)
   printf("File %s could not be opened\n",file_name);

 memset(file_name,'\0',256);
 sprintf(file_name,"%s_d%d.out",MEASURED_SPEED_FILE,delay);
 if((predicted_eye_vel_file=fopen(file_name,"w"))==NULL)
   printf("File %s could not be opened\n",file_name);

 memset(file_name,'\0',256);
 sprintf(file_name,"%s_d%d.out",AREA_COVERED_FILE,delay);
 if((area_cov_file=fopen(file_name,"w"))==NULL)
   printf("File %s could not be opened\n",file_name);

 for(i=0;i<FIRST_FRAME;i++)
 {
   if(frame[i].gaze_point>0)
   {
     Vtt_x=frame[i].Ret_X();
     Vtt_y=frame[i].Ret_Y();
//     printf("CHECK VAL: %d %d\n",Vtt_x,Vtt_y);
   }

   /*Filling filtering file for transcoder*/
   fprintf(filtered_eye_data_file,"Frame %d  %d  %d  %d\n",i,i,i,i);
   fprintf(filtered_eye_data_file,"%d  %d  0  0  0\n",frame[i].Ret_X(),frame[i].Ret_Y());
   /***************************************/
 }
// printf("CHECK VAL: %d %d\n",Vtt_x,Vtt_y);

// printf("CHECK VAL: %d\n",Fmax);
// getchar();
 for(i=FIRST_FRAME;i<Fmax-delay+1;i++)
 {
   frame_count++;
   mb_frame_count++;
   if(frame[i].gaze_point>0)
   {
     for(j=0;j<frame[i].gaze_point;j++)
     {
       Vt_x+=abs(frame[i].x[j]-Vtt_x);
       Vt_y+=abs(frame[i].y[j]-Vtt_y);
       Vtt_x=frame[i].x[j];
       Vtt_y=frame[i].y[j];
//       printf("CHECK VAL: %d %d\n",Vt_x,Vt_y);
     }
   }

   /*Filling filtering file for transcoder*/
   fprintf(filtered_eye_data_file,"Frame %d  %d  %d  %d\n",i,i,i,i);
   fprintf(filtered_eye_data_file,"%d  %d  %d  %d  CW\n",Vtt_x,Vtt_y,x_mov,y_mov);

//   printf("CHECK\n");
    mb_in_window=0;
    mb_out_window=0;
    x1=(Vtt_x*mb_width/100.0);
    y1=(Vtt_y*mb_height2/100.0);
    a=(x_mov*mb_width/100.0);
    b=(y_mov*mb_height2/100.0);

    for (k = 0; k < mb_height2; k++)
      for (n = 0; n < mb_width; n++)
      {
        if(In_Window(ceil(x1),ceil(y1),n,k,ceil(a),ceil(b))==1)
	{
	  mb_in_window++;
	}
	else
	{
	  mb_out_window++;
	}
      }
     av_area_coverage+=100.0*mb_in_window/(mb_height2*mb_width);
//     printf("CUR=%f   TOT=%f\n",100.0*in_window/(mb_height2*mb_width),av_area_coverage/frame_count);
//     printf("PRINTING\n");
     fprintf(area_cov_file,"%f  %f\n",100.0*mb_in_window/(mb_height2*mb_width),av_area_coverage/mb_frame_count);

//     printf("CHECK 1  FN=%d\n",frame_count);

   /***************************************/
   if(frame_count==ceil(FRAME_RATE))
   {
     double Wx=0,Hy=0;
     int m,n,k,g;
     GOP_count++;
     frame_count=0;
//     printf("CHECK VAL new: %d %d\n",Vt_x,Vt_y);
     V_x=Vt_x/FRAME_RATE;
     V_y=Vt_y/FRAME_RATE;
//     printf("CHECK VAL new1: %f %f\n",V_x,V_y);
     Wx=W*V_x/100;
     Hy=H*V_y/100;
//     printf("CHECK VAL new2: %f %f\n",Wx,Hy);


     if(ceil(Wx)>x_max_vel)
       x_max_vel=ceil(Wx);
     if(ceil(Hy)>y_max_vel)
       y_max_vel=ceil(Hy);
     n=ceil(Wx/X_SHIFT);
     m=ceil(Hy/Y_SHIFT);
     vel_ar_x[n]++;
     vel_ar_y[m]++;

     count++;

     //Calculate ACURACY
//     printf("CHECK VEL: %d %d n=%d m=%d\n",x_max_vel,y_max_vel,n,m);
     gaze_coeff=ceil(acuity*GOP_count/100.0);
//     printf("GAZE cooef %d\n",gaze_coeff);
     k=0;
     for(g=0;g<ceil(x_max_vel/X_SHIFT)+1;g++)
     {
       k+=vel_ar_x[g];
       if(k>gaze_coeff)
         break;
     }
     x_gaze=g;
     k=0;
     for(g=0;g<ceil(y_max_vel/Y_SHIFT)+1;g++)
     {
       k+=vel_ar_y[g];
       if(k>gaze_coeff)
         break;
     }
     y_gaze=g;
     /*x_mov and y_mov are percentage values */
     x_mov=ceil(100.0*x_gaze*X_SHIFT*koeff/W);
     y_mov=ceil(100.0*y_gaze*Y_SHIFT*koeff/H);

     x_mov_tmp=(x_gaze*X_SHIFT*koeff*0.1/(delay*0.1));
     y_mov_tmp=(y_gaze*X_SHIFT*koeff*0.1/(delay*0.1));

     x_mov_tmp=((180*atan((x_mov_tmp*WP/W)/L))/M_PI);
     y_mov_tmp=((180*atan((y_mov_tmp*HP/H)/L))/M_PI);

//     x_mov_tmp=x_gaze*X_SHIFT;
//     y_mov_tmp=y_gaze*Y_SHIFT*K*0.1/(delay*0.1));

     fprintf(predicted_eye_vel_file,"%f  %f\n",FRAME_RATE*x_mov_tmp,FRAME_RATE*y_mov_tmp);
     dynamic_a+=x_mov;
     dynamic_b+=y_mov;
//     printf("MOV x %d MOV y %d\n",x_mov,y_mov);
//     getchar();
     Vt_x=0;
     Vt_y=0;
  }
  //Counting how good the window was built

  if(GOP_count>0)
  {
     sec_frame_count++;
     if(frame[i].gaze_point>0)
     {
       Xp=frame[i].Ret_X();
       Yp=frame[i].Ret_Y();
     }

     for(j=0;j<frame[i+delay].gaze_point;j++)
     {
//     printf("%d %d %d %d %d %d\n",frame[i+delay].x[j],frame[i+delay].y[j],Xp,Yp,x_mov,y_mov);
//       printf("%d\n",In_Window(frame[i+delay].x[j],frame[i+delay].y[j],Xp,Yp,x_mov,y_mov));
       if(In_Window(frame[i+delay].x[j],frame[i+delay].y[j],Xp,Yp,x_mov,y_mov))
       {
         in_count++;
         sec_in_count++;
       }
       else
       {
         out_count++;
         sec_out_count++;
       }

       fprintf(filtered_eye_data_file,"%d  %d  0  0  RG\n",frame[i+delay].x[j],frame[i+delay].y[j]);
       //RG - real gaze
     }

     for(j=0;j<frame[i].gaze_point;j++)
     {
       fprintf(filtered_eye_data_file,"%d  %d  0  0  DG\n",frame[i].x[j],frame[i].y[j]);
       //DG - delayed gaze
     }

//     fprintf(filtered_eye_data_file,"%d  %d  %d  %d  CW\n",Vtt_x,Vtt_y,x_mov,y_mov);

     if(sec_frame_count==FRAME_RATE)
     {
/*
       fprintf(acuity_file,"%3.2f      %.6f     %.6f\n",
       100.0*sec_in_count/(sec_in_count+sec_out_count),
       M_PI*x_mov_tmp*y_mov_tmp/(16.0*16.0),
       (100.0*M_PI*x_mov*y_mov/10000.0));
*/
       fprintf(acuity_file,"%f\n",100.0*sec_in_count/(sec_in_count+sec_out_count));
       sec_in_count=0;
       sec_out_count=0;
       sec_frame_count=0;
     }
  }
  else
  {
    if(frame[i].gaze_point>0)
    {
      Xp=frame[i].Ret_X();
      Yp=frame[i].Ret_Y();
    }
  }
}
 fclose(acuity_file);
 fclose(filtered_eye_data_file);
 fclose(predicted_eye_vel_file);
 fclose(area_cov_file);
 printf("Dynamic window DELAY %d,  Given acuity %d,  Given vel koeff %d.\n",delay,acuity,koeff);
// printf("In window = %d,  Out of window = %d x_mov=%d y_mov=%d\n",in_count,out_count,x_mov,y_mov);
// printf("DYNAMIC count=%d\n",count);
// printf("Dynamic window size ");
// tempf=dynamic_a/GOP_count;
// printf("%d ",(int)tempf);
// tempf=dynamic_b/GOP_count;
// printf("%d \n",(int)tempf);
 printf("In Dynamic Window %f%% gazes\n",100*0.1*in_count/(0.1*(in_count+out_count)));
 printf("Av area coverage: %f%% \n",av_area_coverage/mb_frame_count);
// printf("Average Dynamic Window %.6f\n",(M_PI*dynamic_a*dynamic_b/(100.0*GOP_count*GOP_count)));
// printf("%f\n",180.0*atan((9*145.0)/(32*480.0))/M_PI);
// printf("%f\n",tan(M_PI*4/180.0)*L*H/13.25);
// printf("%f\n",M_PI*240*225*100/(H*Wm));
 printf("\n\n");
}



/*************************************** M A I N ***************************/



int main(int argc, char *argv[])
{

// printf("Argc %d  %s\n",argc,argv[1]);

 chdir("in_data");
 if((in_data_file=fopen(IN_DATA_EYE_FILE,"r"))==NULL)
   printf("File IN_DATA_EYE_FILE could not be opened\n");
// if((in_data_file=fopen("toy_car_eye.out","r"))==NULL)
//  printf("File %s could not be opened\n",argv[1]);

 chdir("../out_data");
 if((ang_vel_file=fopen(ANG_VEL_FILE,"w"))==NULL)
  printf("File ANG_VEL_FILE could not be opened\n");
 if((pix_vel_file=fopen(PIX_VEL_FILE,"w"))==NULL)
  printf("File PIX_VEL_FILE could not be opened\n");


 Vt_x=0;
 Vt_y=0;
 while(!feof(in_data_file))
 {
    fscanf(in_data_file,"%s %s\n",X,Y);
    if(strcmp(X,"Frame")==0)
    {
       current_frame=atoi(Y);
       if(current_frame>=FIRST_FRAME)
         frame_count++;
       Fmax++;
       if(Fmax>FIRST_FRAME)
         gen_frame_count++;

//      printf("Frame number %d\n",current_frame);
    }
    else
    {
       x=atoi(X);
       y=atoi(Y);
//      printf("CHECK: %.1f %.1f\n",Vtt_x,Vtt_y);
      total_gaze_count++;
      /*Filtering some gazes*/
      if(x==0||x==100)
        if(abs(x-Vtt_x)>X_TRESHHOLD)
        {
          x=Vtt_x;
          x_filter_count++;
        }
      if(y==0||y==100)
        if(abs(y-Vtt_y)>Y_TRESHHOLD)
        {
          y=Vtt_y;
          y_filter_count++;
        }
      /*End of filtering*/
      frame[Fmax-1].Add_Point(x,y);
      if(current_frame>=FIRST_FRAME)
      {
        gaze_point_count++;
        Vt_x+=abs(x-Vtt_x);
        Vt_y+=abs(y-Vtt_y);
      }
      Vtt_x=x;
      Vtt_y=y;
    }
    if(frame_count==FRAME_RATE)
    {
      double Wx=0,Hy=0;
      GOP_count++;
      frame_count=0;
      V_x=0.1*Vt_x/(0.1*FRAME_RATE);
      V_y=0.1*Vt_y/(0.1*FRAME_RATE);
      Wx=W*V_x/100;
      Hy=H*V_y/100;
//      printf("%d    %d\n",Vt_x,Vt_y);
      Va_x+=Wx;
      Va_y+=Hy;
      //For static window calculation

      if(GOP_count>0)
      {
        int n,m;
        if(Wx>x_max_vel)
          x_max_vel=ceil(Wx);
        if(Hy>y_max_vel)
          y_max_vel=ceil(Hy);
        n=ceil(Wx/X_SHIFT);
        m=ceil(Hy/Y_SHIFT);
        vel_ar_x[n]++;
        vel_ar_y[m]++;
        count++;
      }

      Vt_x=0;
      Vt_y=0;
      //Eye speed in degrees/sec
        fprintf(ang_vel_file,"%.6f    %.6f\n",FRAME_RATE*(180*atan((Wx*WP/W)/L))/M_PI,FRAME_RATE*(180*atan((Hy*HP/H)/L))/M_PI);
      //Eye speed in pixels
        fprintf(pix_vel_file,"%2.2f    %2.2f\n",FRAME_RATE*Wx,FRAME_RATE*Hy);

      velocity_count++;
    }
 }

 Va_x=Va_x/velocity_count;
 Va_y=Va_y/velocity_count;
 fclose(ang_vel_file);
 fclose(pix_vel_file);
 fclose(in_data_file);

 //
 printf("Filtered X=%f, Y=%f\n\n\n",100.0*x_filter_count/total_gaze_count,100.0*y_filter_count/total_gaze_count);


 //DYNAMIC WINDOW CALCULATIONS

// Experiments with Seven as a subject
/* Car video - 120Hz */
// Dynamic_Window(5, 4, 85);
//Dynamic_Window(30, 10, 86);

/* Shamu video - 120Hz */
// Dynamic_Window(5, 5, 90);
// Dynamic_Window(30, 11, 93);

/* Airplaine video - 120Hz */
//Dynamic_Window(5, 4, 86);
//Dynamic_Window(30, 9, 85);

 /* Car video modes - 60Hz*/
// Dynamic_Window(5, 6, 92);
// Dynamic_Window(30, 10, 86);

 /* Car video modes - 60Hz*/
// Dynamic_Window(5, 6, 55);
// Dynamic_Window(30, 10, 58);

 /*Car video modes - 60Hz*/
//Dynamic_Window(5, 6, 63);
//Dynamic_Window(30, 10, 80);

 if((par_file=fopen("../test.par","r"))==NULL)
   printf("File test.par could not be opened\n");
 else
 {
   int temp_K, temp_TA, temp_D;
   while(!feof(par_file))
   {     
     fscanf(par_file,"%d  %d  %d\n",&temp_K, &temp_TA, &temp_D);
//     printf("%d  %d  %d\n",temp_K, temp_TA, temp_D);    
     Dynamic_Window(temp_D, temp_K, temp_TA);
   }
 }  

 return 0;
}









/*
  if((outfile=fopen("SW_acuty5","w"))==NULL)
    printf("File code.out could not be opened\n");
 //STATIC WINDOW CALCULATIONS
 gaze_coeff=ceil(ACUTY*GOP_count/100.0);
 j=0;
 for(i=0;i<ceil(0.1*x_max_vel/(0.1*X_SHIFT))+1;i++)
 {
   j+=vel_ar_x[i];
   if(j>gaze_coeff)
     break;
 }
 x_gaze=i;
 j=0;
 for(i=0;i<ceil(0.1*y_max_vel/(0.1*Y_SHIFT))+1;i++)
 {
   j+=vel_ar_y[i];
   if(j>gaze_coeff)
     break;
 }
 y_gaze=i;

 x_mov=ceil(100.0*x_gaze*X_SHIFT*K/W);
 y_mov=ceil(100.0*y_gaze*Y_SHIFT*K/H);
 printf("\nCHECK %d %d\n",x_mov,y_mov);
 in_count=0;
 out_count=0;
 for(i=0;i<Fmax-DELAY+1;i++)
 {
   if(i>FIRST_FRAME)
   {
     sec_frame_count++;
     if(frame[i].gaze_point>0)
     {
       Xp=frame[i].Ret_X();
       Yp=frame[i].Ret_Y();
     }

     for(j=0;j<frame[i+DELAY].gaze_point;j++)
     {
//     printf("%d %d %d %d %d %d\n",frame[i+DELAY].x[j],frame[i+DELAY].y[j],Xp,Yp,x_mov,y_mov);
//       printf("%d\n",In_Window(frame[i+DELAY].x[j],frame[i+DELAY].y[j],Xp,Yp,x_mov,y_mov));
       if(In_Window(frame[i+DELAY].x[j],frame[i+DELAY].y[j],Xp,Yp,x_mov,y_mov))
       {
         in_count++;
         sec_in_count++;
       }
       else
       {
         out_count++;
         sec_out_count++;
       }
     }

     if(sec_frame_count==FRAME_RATE)
     {
       fprintf(outfile,"%3.2f      %.6f     %.6f\n",
       100.0*sec_in_count/(sec_in_count+sec_out_count),M_PI*x_mov*y_mov/(16.0*16.0),
       (100.0*M_PI*x_mov*y_mov/(16.0*16.0))/(H*W/(16.0*16.0)));
       sec_in_count=0;
       sec_out_count=0;
       sec_frame_count=0;
     }
   }
   else
   {
     if(frame[i].gaze_point>0)
     {
       Xp=frame[i].Ret_X();
       Yp=frame[i].Ret_Y();
     }
   }
 }
 fclose(outfile);
// printf("STATIC count=%d\n",count);
 printf("\nStatic Window size %d %d\n",x_mov,y_mov);
// printf("In window = %d,  Out of window = %d\n",in_count,out_count);
 printf("In Static Window %f%\n",100*0.1*in_count/(0.1*(in_count+out_count)));
 printf("Average Static Window %.0f\n",(M_PI*x_mov*y_mov));


 if((outfile=fopen("eye.out","w"))==NULL)
    printf("File acuty.out could not be opened\n");
 for(i=0;i<Fmax;i++)
 {
   fprintf(outfile,"Frame %d\n",i);
   frame[i].Print_File();
//   getchar();
 }
 fclose(outfile);
*/



